//Cwiczenia 13
#include <windows.h>

#include <d3d11.h>
#include <dxgi.h>

#include "VS.h"
#include "PS.h"

#include <DirectXMath.h>
using namespace DirectX;
#include <cmath>

//Definicja nazwy apliacji
#define APPNAME "Przykad do wicze 13"

//pomocnicze definicje i typy
const float PI = 3.1415927f;
const float ROTSPEEDPERSEC = (PI/2.0f)/1000.0f;

//Dane geometryczne szecianu
const int NUMOFCUBEVERTICES = 36; 
const int EMPTYSTART = 36;			//Indeks poczatku podlogi i sufitu
const int VERTEXBYTESIZE = 8*sizeof(float);
float vertices[] = {
	//Pozycja               Wektor normalny         Wspolrzedne tekstury

	//Szescian
	-1.0f, 1.0f,-1.0f,  0.0f,0.0f,-1.0f,        0.0f, 0.0f,
	 1.0f, 1.0f,-1.0f,	0.0f,0.0f,-1.0f,        1.0f, 0.0f,
	-1.0f,-1.0f,-1.0f,	0.0f,0.0f,-1.0f,        0.0f, 1.0f,

	 1.0f, 1.0f,-1.0f,  0.0f,0.0f,-1.0f,        1.0f, 0.0f,
	 1.0f,-1.0f,-1.0f,	0.0f,0.0f,-1.0f,        1.0f, 1.0f,
	-1.0f,-1.0f,-1.0f,	0.0f,0.0f,-1.0f,        0.0f, 1.0f,

	 1.0f, 1.0f,-1.0f,  1.0f,0.0f, 0.0f,        0.0f, 0.0f,
	 1.0f, 1.0f, 1.0f,	1.0f,0.0f, 0.0f,        1.0f, 0.0f,
	 1.0f,-1.0f,-1.0f,	1.0f,0.0f, 0.0f,        0.0f, 1.0f,

	 1.0f, 1.0f, 1.0f,  1.0f,0.0f, 0.0f,        1.0f, 0.0f,
	 1.0f,-1.0f, 1.0f,	1.0f,0.0f, 0.0f,        1.0f, 1.0f,
	 1.0f,-1.0f,-1.0f,	1.0f,0.0f, 0.0f,        0.0f, 1.0f,

	 1.0f, 1.0f, 1.0f,  0.0f,0.0f, 1.0f,        0.0f, 0.0f,
	-1.0f, 1.0f, 1.0f,	0.0f,0.0f, 1.0f,        1.0f, 0.0f,
	 1.0f,-1.0f, 1.0f,	0.0f,0.0f, 1.0f,        0.0f, 1.0f,

	-1.0f, 1.0f, 1.0f,  0.0f,0.0f, 1.0f,        1.0f, 0.0f,
	-1.0f,-1.0f, 1.0f,	0.0f,0.0f, 1.0f,        1.0f, 1.0f,
	 1.0f,-1.0f, 1.0f,	0.0f,0.0f, 1.0f,        0.0f, 1.0f,

	-1.0f, 1.0f, 1.0f,  -1.0f,0.0f,0.0f,        0.0f, 0.0f,
	-1.0f, 1.0f,-1.0f,	-1.0f,0.0f,0.0f,        1.0f, 0.0f,
	-1.0f,-1.0f, 1.0f,	-1.0f,0.0f,0.0f,        0.0f, 1.0f,

	-1.0f, 1.0f,-1.0f,  -1.0f,0.0f,0.0f,        1.0f, 0.0f,
	-1.0f,-1.0f,-1.0f,	-1.0f,0.0f,0.0f,        1.0f, 1.0f,
	-1.0f,-1.0f, 1.0f,	-1.0f,0.0f,0.0f,        0.0f, 1.0f,

	-1.0f, 1.0f, 1.0f,  0.0f,1.0f, 0.0f,        0.0f, 0.0f,
	 1.0f, 1.0f, 1.0f,	0.0f,1.0f, 0.0f,        1.0f, 0.0f,
	-1.0f, 1.0f,-1.0f,	0.0f,1.0f, 0.0f,        0.0f, 1.0f,

	 1.0f, 1.0f, 1.0f,  0.0f,1.0f, 0.0f,        1.0f, 0.0f,
	 1.0f, 1.0f,-1.0f,	0.0f,1.0f, 0.0f,        1.0f, 1.0f,
	-1.0f, 1.0f,-1.0f,	0.0f,1.0f, 0.0f,        0.0f, 1.0f,

	-1.0f,-1.0f,-1.0f,  0.0f,-1.0f, 0.0f,       0.0f, 0.0f,
	 1.0f,-1.0f,-1.0f,	0.0f,-1.0f, 0.0f,       1.0f, 0.0f,
	-1.0f,-1.0f, 1.0f,	0.0f,-1.0f, 0.0f,       0.0f, 1.0f,

	 1.0f,-1.0f,-1.0f,  0.0f,-1.0f, 0.0f,       1.0f, 0.0f,
	 1.0f,-1.0f, 1.0f,	0.0f,-1.0f, 0.0f,       1.0f, 1.0f,
	-1.0f,-1.0f, 1.0f,	0.0f,-1.0f, 0.0f,       0.0f, 1.0f,

	//Podloga i sufit
	-1.0f, -1.0f, 1.0f,  0.0f,1.0f, 0.0f,        0.0f, 0.0f,
	 1.0f, -1.0f, 1.0f,	0.0f,1.0f, 0.0f,        1.0f, 0.0f,
	-1.0f, -1.0f,-1.0f,	0.0f,1.0f, 0.0f,        0.0f, 1.0f,

	 1.0f, -1.0f, 1.0f,  0.0f,1.0f, 0.0f,        1.0f, 0.0f,
	 1.0f, -1.0f,-1.0f,	0.0f,1.0f, 0.0f,        1.0f, 1.0f,
	-1.0f, -1.0f,-1.0f,	0.0f,1.0f, 0.0f,        0.0f, 1.0f,

	-1.0f, 1.0f,-1.0f,  0.0f,-1.0f, 0.0f,       0.0f, 0.0f,
	 1.0f, 1.0f,-1.0f,	0.0f,-1.0f, 0.0f,       1.0f, 0.0f,
	-1.0f, 1.0f, 1.0f,	0.0f,-1.0f, 0.0f,       0.0f, 1.0f,

	 1.0f, 1.0f,-1.0f,  0.0f,-1.0f, 0.0f,       1.0f, 0.0f,
	 1.0f, 1.0f, 1.0f,	0.0f,-1.0f, 0.0f,       1.0f, 1.0f,
	-1.0f, 1.0f, 1.0f,	0.0f,-1.0f, 0.0f,       0.0f, 1.0f
};

//Struktury reprezentujace bufory stale VS
// - statyczny
struct VS_CONSTANT_BUFFER_CONST
{
	XMFLOAT4 colLight;
	XMFLOAT4 dirLight;
};
// - dynamiczny
struct VS_CONSTANT_BUFFER_VAR
{
	XMFLOAT4X4 matWorldView;
	XMFLOAT4X4 matView;
	XMFLOAT4X4 matWorldViewProj;
	XMFLOAT4 colMaterial;
};

//Ustawienia materialu i swiatla
const float lightColor[4] = {1.0f, 1.0f, 1.0f, 1.0f };
const float materialColor[4] = { 1.0f, 1.0f, 1.0f, 1.0f };
const float lightDir[4] = { 0.0f, -0.5f, 1.0f, 0.0f };

//Kolor ta
const float background[4] = { 0.0f, 0.0f, 0.0f, 1.0f };

//Buduje tekstur D3D11 (interfejsy ID3D11Texture2D i ID3D11ShaderResourceView)
//dla zadanego numeru zasobu
void BuildD3D11Texture2DFromResource(HINSTANCE hInstance, HWND hWnd, int resourceID, ID3D11Device *pDevice, ID3D11Texture2D **ppTexture, ID3D11ShaderResourceView **ppShaderResourceView)
{
	HDC hdcBmp;		//kontekst pamieciowy dla DDB wczytanej z zasobow
	HBITMAP hBmp;	//uchwyt DDB
	BITMAP bmp;		//struktura informacji o DDB
	float * bmpBitsFloat = NULL;	
	COLORREF pixColor;
	D3D11_TEXTURE2D_DESC sTextureDesc;
	D3D11_SUBRESOURCE_DATA sTextureInit;

	//Budowa tekstury sufitu
	hBmp = LoadBitmap(hInstance, MAKEINTRESOURCE(resourceID));
	hdcBmp = CreateCompatibleDC(GetDC(hWnd));
	SelectObject(hdcBmp,hBmp);
	GetObject(hBmp,sizeof(BITMAP),&bmp);			
	bmpBitsFloat = new float[bmp.bmWidth*bmp.bmHeight*4];
	//Wpelnienie tablicy kolorami pikseli
	for (int w=0;w<bmp.bmHeight;w++)
	for (int k=0;k<bmp.bmWidth;k++)
	{						
		pixColor = GetPixel(hdcBmp,k,w);
		bmpBitsFloat[4*(k+w*bmp.bmWidth)  ] = (pixColor%256)/255.0f;
		pixColor = pixColor/256;
		bmpBitsFloat[4*(k+w*bmp.bmWidth)+1] = (pixColor%256)/255.0f;
		pixColor = pixColor/256;
		bmpBitsFloat[4*(k+w*bmp.bmWidth)+2] = (pixColor%256)/255.0f;
		pixColor = pixColor/256;
		bmpBitsFloat[4*(k+w*bmp.bmWidth)+3] = (pixColor)/255.0f;
	}
	ReleaseDC(hWnd,hdcBmp);
	//Utworzenie interfejsu tekstury i zasobu shadera
	sTextureDesc.Width = bmp.bmWidth;
	sTextureDesc.Height = bmp.bmHeight;
	sTextureDesc.MipLevels = 1;
	sTextureDesc.ArraySize = 1;
	sTextureDesc.Format = DXGI_FORMAT_R32G32B32A32_FLOAT;      
	sTextureDesc.SampleDesc.Count = 1;
	sTextureDesc.SampleDesc.Quality = 0;
	sTextureDesc.Usage = D3D11_USAGE_DEFAULT;
	sTextureDesc.BindFlags = D3D11_BIND_SHADER_RESOURCE;
	sTextureDesc.CPUAccessFlags = 0;
	sTextureDesc.MiscFlags = 0;
	sTextureInit.pSysMem = bmpBitsFloat;
	sTextureInit.SysMemPitch = 16*bmp.bmWidth;
	sTextureInit.SysMemSlicePitch = 16*bmp.bmWidth*bmp.bmHeight;
	pDevice->CreateTexture2D(&sTextureDesc,&sTextureInit,ppTexture);
	pDevice->CreateShaderResourceView(*ppTexture,NULL,ppShaderResourceView);	  
	if (bmpBitsFloat) delete[] bmpBitsFloat;
}

LRESULT CALLBACK ProcOkna(HWND, UINT, WPARAM, LPARAM);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	WNDCLASS wndclass;
	HWND hwnd;
	MSG msg;
	RECT pulpit;

	wndclass.style = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
	wndclass.lpfnWndProc = ProcOkna;
	wndclass.cbClsExtra = 0;
	wndclass.cbWndExtra = 0;
	wndclass.hInstance = hInstance;
	wndclass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
	wndclass.hCursor = LoadCursor(NULL, IDC_ARROW);
	wndclass.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wndclass.lpszMenuName = NULL;
	wndclass.lpszClassName = "Szkielet_D3D11";

	if (!RegisterClass(&wndclass))
	{
		MessageBox(NULL, "Nie udalo sie zarejestrowac klasy okna!", APPNAME, MB_ICONERROR);
		return 0;
	}

	GetClientRect(GetDesktopWindow(),&pulpit);
	hwnd = CreateWindow("Szkielet_D3D11", APPNAME, WS_POPUP, CW_USEDEFAULT, CW_USEDEFAULT, pulpit.right-pulpit.left, pulpit.bottom-pulpit.top, NULL, NULL, hInstance, NULL);

	if (hwnd == NULL)
	{
		MessageBox(NULL, "Nie udalo sie utworzyc okna!", APPNAME, MB_ICONERROR);
		UnregisterClass("Szkielet_D3D11", hInstance);
		return 0;
	}

	ShowWindow(hwnd, nCmdShow);
	UpdateWindow(hwnd);

	do
    {
                
        if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
        {
            	if (msg.message != WM_QUIT)
 				{
 					TranslateMessage(&msg);
            		DispatchMessage(&msg);
 				}
        }
        else
        {
                InvalidateRect(hwnd,NULL,false);
        }
    }
    while (msg.message != WM_QUIT);

	UnregisterClass("Szkielet_D3D11", hInstance);
	return msg.wParam;
}

LRESULT CALLBACK ProcOkna(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	//Zmienne potrzebne do zainicjowania Direct3D 11
	static ID3D11Device * pD3D11Device = NULL;
	static ID3D11DeviceContext * pD3D11DeviceContext = NULL;
	static IDXGISwapChain * pSwapChain = NULL;
	static ID3D11Texture2D * pBackBuffer = NULL;
	static ID3D11RenderTargetView *pRenderTargetView = NULL;
	static D3D_FEATURE_LEVEL d3dFeatureLevel;
	static DXGI_SWAP_CHAIN_DESC scDesc;

	//Dodatkowe zmienne
	static HRESULT hr;	
	static RECT client;

	//Zmienne zwiazane z buforem wierzcholkow
	static D3D11_BUFFER_DESC vbDesc;
	static D3D11_SUBRESOURCE_DATA vbInit;
	static ID3D11Buffer * pVertexBuffer = NULL;
	static UINT stride = VERTEXBYTESIZE; //rozmiar wierzcholka w bajtach
	static UINT offset = 0;
	
	//Zmienne zwiazane z opisem ukladu danych wejsciowych potoku
	static D3D11_INPUT_ELEMENT_DESC ieDesc[3];
	static ID3D11InputLayout *pInputLayout = NULL;
	static ID3D11VertexShader * pVertexShader = NULL;
	static ID3D11PixelShader * pPixelShader = NULL;
	
	//Zmienna zwiazana z rasteryzacja
	static D3D11_VIEWPORT sViewport;
	static D3D11_RASTERIZER_DESC sRastDesc;
	static ID3D11RasterizerState * pRasterState = NULL;

	//Zmienne zwizane z buforem staym VS
	static VS_CONSTANT_BUFFER_CONST sVSCBufferConst;
	static VS_CONSTANT_BUFFER_VAR sVSCBufferVar;
	static D3D11_BUFFER_DESC cbDesc;
	static D3D11_SUBRESOURCE_DATA cbInit;
	static ID3D11Buffer *pVSCBuffer[2] = {NULL,NULL};
	static D3D11_MAPPED_SUBRESOURCE sMappedResource;
	static VS_CONSTANT_BUFFER_VAR *	pCBuffer = NULL;	

	//Zmienne zwizane z buforem gbokoci
	static D3D11_TEXTURE2D_DESC sDSDesc;
	static ID3D11Texture2D * pDSBuffer;
	static ID3D11DepthStencilView * pDSView;

	//Zmienne zwiazane z teksturami 2D
	static ID3D11Texture2D * pTextureCeil = NULL;
	static ID3D11ShaderResourceView * pSRViewCeil = NULL;
	static ID3D11Texture2D * pTextureFloor = NULL;
	static ID3D11ShaderResourceView * pSRViewFloor = NULL;	
	static ID3D11Texture2D * pTextureWall = NULL;
	static ID3D11ShaderResourceView * pSRViewWall = NULL;
	// - i ze stanem probkowania
	static D3D11_SAMPLER_DESC sSamplerDesc;//Opis stanu probkowania
	static ID3D11SamplerState * pSampler = NULL;//Interfejs stanu probkowania

	//Zmienne sterujace synchronizacja animacji
	static int czas_klatki, czas;

	//Macierze przeksztace
	static XMMATRIX wvpMatrix, wvMatrix, vMatrix;
	static XMMATRIX wMatrix, pMatrix;

	//Dodatkowe zmienne
	static float angle = -PI/2.0f;
	static bool CzySzescian = true;

	switch (uMsg)
	{
		case WM_CREATE:
			//Pierwsze zmierzenie czasu do synchronizacji animacji
			czas = GetTickCount();			
			
			//Wypelnienie struktury opisu lancucha wymiany
			GetClientRect(hwnd,&client);
			ZeroMemory(&scDesc,sizeof(scDesc));
			scDesc.BufferDesc.Width = client.right - client.left;
			scDesc.BufferDesc.Height = client.bottom - client.top;
			scDesc.BufferDesc.Format = DXGI_FORMAT_R8G8B8A8_UNORM;
			scDesc.BufferDesc.RefreshRate.Numerator = 60;
			scDesc.BufferDesc.RefreshRate.Denominator = 1;
			scDesc.BufferDesc.Scaling = DXGI_MODE_SCALING_UNSPECIFIED;
			scDesc.BufferDesc.ScanlineOrdering = DXGI_MODE_SCANLINE_ORDER_UNSPECIFIED;
			scDesc.SampleDesc.Count = 1;
			scDesc.SampleDesc.Quality = 0;
			scDesc.BufferUsage = DXGI_USAGE_RENDER_TARGET_OUTPUT;
			scDesc.BufferCount = 1;
			scDesc.OutputWindow = hwnd;
			scDesc.Windowed = true;
			scDesc.SwapEffect = DXGI_SWAP_EFFECT_DISCARD;
			scDesc.Flags = 0;
	
			//Utworzenie urzadzenia Direct3D 11, jego kontekstu i lancucha wymiany
			hr = D3D11CreateDeviceAndSwapChain( NULL, D3D_DRIVER_TYPE_HARDWARE, NULL, D3D11_CREATE_DEVICE_SINGLETHREADED, NULL, 0, D3D11_SDK_VERSION, &scDesc, &pSwapChain, &pD3D11Device, &d3dFeatureLevel, &pD3D11DeviceContext );
			if (hr != S_OK)
			{
				MessageBox(NULL, "Nie udalo sie wywolac funkcji D3D11CreateDeviceAndSwapChain!", APPNAME, MB_ICONERROR);
				return 0;
			}			

			//Uzyskanie dostepu do bufora tylnego lancucha wymiany
			hr = pSwapChain->GetBuffer( 0, __uuidof(pBackBuffer),reinterpret_cast<void**>(&pBackBuffer) );
			if (hr != S_OK)
			{
				MessageBox(NULL, "Nie udalo sie wywolac metody IDXGISwapChain::GetBuffer!", APPNAME, MB_ICONERROR);
				return 0;
			}

			//Utworzenie widoku celu renderowania powiazanego z buforem tylnym
			hr = pD3D11Device->CreateRenderTargetView( pBackBuffer, NULL, &pRenderTargetView );
			if (hr != S_OK)
			{
				MessageBox(NULL, "Nie udalo sie wywolac metody ID3D11Device::CreateRenderTargetView!", APPNAME, MB_ICONERROR);
				return 0;
			}
			
			//Przygotowanie bufora wierzcholkow
			vbDesc.ByteWidth = sizeof(vertices);
			vbDesc.Usage = D3D11_USAGE_DEFAULT;
			vbDesc.BindFlags = D3D11_BIND_VERTEX_BUFFER;
			vbDesc.CPUAccessFlags = 0;
			vbDesc.MiscFlags = 0;
			vbDesc.StructureByteStride = 0;
			vbInit.pSysMem = vertices;
			vbInit.SysMemPitch = 0;
			vbInit.SysMemSlicePitch = 0;
			pD3D11Device->CreateBuffer( &vbDesc,&vbInit,&pVertexBuffer );
			
			//Przygotowanie opisu ukadu danych
			ieDesc[0].SemanticName = "POSITION";
			ieDesc[0].SemanticIndex = 0;
			ieDesc[0].Format = DXGI_FORMAT_R32G32B32_FLOAT;
			ieDesc[0].InputSlot = 0;
			ieDesc[0].AlignedByteOffset = 0;
			ieDesc[0].InputSlotClass = D3D11_INPUT_PER_VERTEX_DATA;
			ieDesc[0].InstanceDataStepRate = 0;
			ieDesc[1].SemanticName = "NORMAL";
			ieDesc[1].SemanticIndex = 0;
			ieDesc[1].Format = DXGI_FORMAT_R32G32B32_FLOAT;
			ieDesc[1].InputSlot = 0;
			ieDesc[1].AlignedByteOffset = 12;
			ieDesc[1].InputSlotClass = D3D11_INPUT_PER_VERTEX_DATA;
			ieDesc[1].InstanceDataStepRate = 0;
			ieDesc[2].SemanticName = "TEXCOORD"; //nazwa semantyczna wsp. tekstury
			ieDesc[2].SemanticIndex = 0;
			ieDesc[2].Format = DXGI_FORMAT_R32G32_FLOAT; //format danych wsp. tekstury
			ieDesc[2].InputSlot = 0;
			ieDesc[2].AlignedByteOffset = 24; //6*4
			ieDesc[2].InputSlotClass = D3D11_INPUT_PER_VERTEX_DATA;
			ieDesc[2].InstanceDataStepRate = 0;
			pD3D11Device->CreateInputLayout( ieDesc, 3, g_vs_main, sizeof(g_vs_main), &pInputLayout);
						
			//Przygotowanie bufora stalego VS (statycznego)
			sVSCBufferConst.colLight = XMFLOAT4(lightColor);
			sVSCBufferConst.dirLight = XMFLOAT4(lightDir);
			cbDesc.ByteWidth = sizeof(VS_CONSTANT_BUFFER_CONST);
			cbDesc.Usage = D3D11_USAGE_IMMUTABLE;
			cbDesc.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
			cbDesc.CPUAccessFlags = 0;
			cbDesc.MiscFlags = 0;
			cbDesc.StructureByteStride = 0;
			cbInit.pSysMem = &sVSCBufferConst;
			cbInit.SysMemPitch = 0;
			cbInit.SysMemSlicePitch = 0;
			pD3D11Device->CreateBuffer(&cbDesc,&cbInit,&pVSCBuffer[0]);
			
			//Przygotowanie zawartosci bufora stalego VS (dynamicznego)
			XMStoreFloat4x4(&sVSCBufferVar.matWorldView,XMMatrixIdentity());
			XMStoreFloat4x4(&sVSCBufferVar.matView, XMMatrixIdentity());
			XMStoreFloat4x4(&sVSCBufferVar.matWorldViewProj, XMMatrixIdentity());
			sVSCBufferVar.colMaterial = XMFLOAT4(materialColor);
			cbDesc.ByteWidth = sizeof(VS_CONSTANT_BUFFER_VAR);
			cbDesc.Usage = D3D11_USAGE_DYNAMIC;
			cbDesc.BindFlags = D3D11_BIND_CONSTANT_BUFFER;
			cbDesc.CPUAccessFlags = D3D11_CPU_ACCESS_WRITE;
			cbDesc.MiscFlags = 0;
			cbDesc.StructureByteStride = 0;
			cbInit.pSysMem = &sVSCBufferVar;
			cbInit.SysMemPitch = 0;
			cbInit.SysMemSlicePitch = 0;
			pD3D11Device->CreateBuffer(&cbDesc,&cbInit,&pVSCBuffer[1]);

			//Ustawienia stanu rasteryzatora
			sRastDesc.FillMode = D3D11_FILL_SOLID;
			sRastDesc.CullMode = D3D11_CULL_BACK;
			sRastDesc.FrontCounterClockwise = false;
			sRastDesc.DepthBias = 0;
			sRastDesc.DepthBiasClamp = 0.0f;
			sRastDesc.SlopeScaledDepthBias = 0.0f;
			sRastDesc.DepthClipEnable = true;
			sRastDesc.ScissorEnable = false;
			sRastDesc.MultisampleEnable = false;
			sRastDesc.AntialiasedLineEnable = false;
			pD3D11Device->CreateRasterizerState(&sRastDesc, &pRasterState);
			
			//Utworzenie interfejsu shadera wierzcholkowego
			pD3D11Device->CreateVertexShader(g_vs_main,sizeof(g_vs_main),NULL,&pVertexShader);
			
			//Utworzenie interfejsu shadera pikselowego
			pD3D11Device->CreatePixelShader(g_ps_main,sizeof(g_ps_main),NULL,&pPixelShader);
			
			//Ustawienia okna widoku
			sViewport.Width = static_cast<float>(client.right - client.left);
			sViewport.Height = static_cast<float>(client.bottom - client.top);
			sViewport.TopLeftX = 0.0f;
			sViewport.TopLeftY = 0.0f;
			sViewport.MinDepth = 0.0f;
			sViewport.MaxDepth = 1.0f;

			//Przygotowanie bufora gbokoci
			sDSDesc.Width = client.right - client.left;
			sDSDesc.Height = client.bottom - client.top;
			sDSDesc.MipLevels = 1;
			sDSDesc.ArraySize = 1;
			sDSDesc.Format = DXGI_FORMAT_D32_FLOAT;
			sDSDesc.SampleDesc.Count = 1;
			sDSDesc.SampleDesc.Quality = 0;
			sDSDesc.Usage = D3D11_USAGE_DEFAULT;
			sDSDesc.BindFlags=D3D11_BIND_DEPTH_STENCIL;
			sDSDesc.CPUAccessFlags = 0;
			sDSDesc.MiscFlags = 0;
			pD3D11Device->CreateTexture2D(&sDSDesc, 0, &pDSBuffer);
			pD3D11Device->CreateDepthStencilView(pDSBuffer,NULL,&pDSView);

			//Budowa tekstury sufitu
			BuildD3D11Texture2DFromResource(((LPCREATESTRUCT)lParam)->hInstance,hwnd,5001,pD3D11Device,&pTextureCeil,&pSRViewCeil);
			//Budowa tekstury podlogi
			BuildD3D11Texture2DFromResource(((LPCREATESTRUCT)lParam)->hInstance,hwnd,5002,pD3D11Device,&pTextureFloor,&pSRViewFloor);
			//Budowa tekstury scian
			BuildD3D11Texture2DFromResource(((LPCREATESTRUCT)lParam)->hInstance,hwnd,5003,pD3D11Device,&pTextureWall,&pSRViewWall);
			
			//Ustawienie stanu probkowania tekstury
			sSamplerDesc.Filter = D3D11_FILTER_MIN_MAG_MIP_LINEAR;								
			sSamplerDesc.AddressU = D3D11_TEXTURE_ADDRESS_WRAP;
			sSamplerDesc.AddressV = D3D11_TEXTURE_ADDRESS_WRAP;
			sSamplerDesc.AddressW = D3D11_TEXTURE_ADDRESS_WRAP;
			sSamplerDesc.MipLODBias = 0;
			sSamplerDesc.MaxAnisotropy = 1;
			sSamplerDesc.ComparisonFunc = D3D11_COMPARISON_ALWAYS;
			sSamplerDesc.BorderColor[0] = 1.0f;
			sSamplerDesc.BorderColor[1] = 1.0f;
			sSamplerDesc.BorderColor[2] = 1.0f;
			sSamplerDesc.BorderColor[3] = 1.0f;
			sSamplerDesc.MinLOD = 0;
			sSamplerDesc.MaxLOD = D3D11_FLOAT32_MAX;
			// - Utworzenie interfejsu stanu probkowania
			pD3D11Device->CreateSamplerState(&sSamplerDesc,&pSampler);
			
			//Wiazania interfejsow z potokiem
			pD3D11DeviceContext->IASetVertexBuffers( 0,1,&pVertexBuffer,&stride,&offset );
			pD3D11DeviceContext->IASetInputLayout( pInputLayout );
			pD3D11DeviceContext->IASetPrimitiveTopology( D3D11_PRIMITIVE_TOPOLOGY_TRIANGLELIST );
			pD3D11DeviceContext->VSSetConstantBuffers(0, 2, pVSCBuffer);
			pD3D11DeviceContext->VSSetShader( pVertexShader,NULL,0 );
			pD3D11DeviceContext->RSSetViewports( 1, &sViewport );
			pD3D11DeviceContext->RSSetState(pRasterState);
			pD3D11DeviceContext->PSSetShader( pPixelShader,NULL,0 );
			pD3D11DeviceContext->PSSetShaderResources(0,1,&pSRViewWall);
			pD3D11DeviceContext->PSSetSamplers(0,1,&pSampler);
			pD3D11DeviceContext->OMSetRenderTargets(1, &pRenderTargetView, pDSView);		
						
			return 0;	
			
	case WM_PAINT:
		//Synchronizowana zmiana dla animacji
		do
		{
		  czas_klatki = GetTickCount() - czas;
		}
		while (czas_klatki == 0);
		czas = GetTickCount();

		angle+=ROTSPEEDPERSEC*czas_klatki;
		
		if (hr == S_OK)
		{
			//Czyszczenie bufora tylnego oraz gbokoci
			pD3D11DeviceContext->ClearRenderTargetView(pRenderTargetView,background);
			pD3D11DeviceContext->ClearDepthStencilView(pDSView,D3D11_CLEAR_DEPTH, 1.0f,0);

			//Obliczenie macierzy transformacji View-Projection
			GetClientRect(hwnd,&client);
			vMatrix = XMMatrixTranslation(0.0f,0.0f,5.0f);
			pMatrix = XMMatrixPerspectiveFovLH(45.0f,static_cast<float>(client.right-client.left)/(client.bottom-client.top),0.125f,20.0f);
			
			//Przeksztacenie World
			wMatrix = XMMatrixRotationY(angle);

			//Obliczenie pozostalych macierzy posrednich
			wvMatrix = XMMatrixMultiply(wMatrix,vMatrix);
			wvpMatrix = XMMatrixMultiply(wvMatrix,pMatrix);

			//Dynamiczny dostep do bufora stalego VS
			pD3D11DeviceContext->Map(pVSCBuffer[1],0,D3D11_MAP_WRITE_DISCARD, 0, &sMappedResource);
			pCBuffer = reinterpret_cast<VS_CONSTANT_BUFFER_VAR *>(sMappedResource.pData);
			XMStoreFloat4x4(&(pCBuffer->matWorldView), XMMatrixTranspose(wvMatrix));
			XMStoreFloat4x4(&(pCBuffer->matView),XMMatrixTranspose(vMatrix));
			XMStoreFloat4x4(&(pCBuffer->matWorldViewProj), XMMatrixTranspose(wvpMatrix));
			pCBuffer->colMaterial = XMFLOAT4(materialColor);
			pD3D11DeviceContext->Unmap(pVSCBuffer[1],0);

			//Rysowanie szescianu lub sufitu/podlogi
			if (CzySzescian == true)
			{
				pD3D11DeviceContext->PSSetShaderResources(0,1,&pSRViewWall);
				pD3D11DeviceContext->Draw(NUMOFCUBEVERTICES,0);
			}
			else
			{
				pD3D11DeviceContext->PSSetShaderResources(0,1,&pSRViewFloor);
				pD3D11DeviceContext->Draw(6,EMPTYSTART);
				pD3D11DeviceContext->PSSetShaderResources(0,1,&pSRViewCeil);
				pD3D11DeviceContext->Draw(6,EMPTYSTART+6);
			}					

			//Wyswietlenie bufora tylnego
			pSwapChain->Present(0,0);
		}

		//Zatwierdzenie uniewaznionego obszaru okna
		ValidateRect(hwnd,NULL);
		return 0;

	//Obsuga klawiszy
	case WM_KEYDOWN:
		if (wParam == VK_ESCAPE)
			DestroyWindow(hwnd);
		else
		{
			if (wParam == '1')
				CzySzescian = true;
			if (wParam == '2')
				CzySzescian = false;
		}
        return 0;	

	case WM_DESTROY:
		//Zwolnienie zasobow zajmowanych przez Direct3D 11
		if (pSRViewCeil) pSRViewCeil->Release();
		if (pTextureCeil) pTextureCeil->Release();
		if (pSRViewFloor) pSRViewFloor->Release();
		if (pTextureFloor) pTextureFloor->Release();
		if (pSRViewWall) pSRViewWall->Release();
		if (pTextureWall) pTextureWall->Release();
		if (pSampler) pSampler->Release();		
		if (pVSCBuffer[0]) pVSCBuffer[0]->Release();
		if (pVSCBuffer[1]) pVSCBuffer[1]->Release();
		if (pRasterState) pRasterState->Release();
		if (pDSBuffer) pDSBuffer->Release();
		if (pDSView) pDSView->Release();
		if (pVertexBuffer) pVertexBuffer->Release();
		if (pInputLayout) pInputLayout->Release();
		if (pVertexShader)	pVertexShader->Release();
		if (pPixelShader) pPixelShader->Release();
		if (pRenderTargetView) pRenderTargetView->Release();
		if (pSwapChain) pSwapChain->Release();
		if (pD3D11DeviceContext) pD3D11DeviceContext->Release();
		if (pD3D11Device) pD3D11Device->Release();				

		PostQuitMessage(0);
		return 0;
	}
	return DefWindowProc(hwnd, uMsg, wParam, lParam);
}