cbuffer VS_CONSTANT_BUFFER_CONST
{
	float4 colLight;
	float4 dirLight;
};

cbuffer VS_CONSTANT_BUFFER_VAR
{
	float4x4 matWorldView;
	float4x4 matView;
	float4x4 matWorldViewProj;
	float4 colMaterial;
};

void main(	in float3 posIn : POSITION, 
            in float3 normIn : NORMAL,
			in float2 texIn : TEXCOORD,
		    out float4 posOut : SV_POSITION,
			out float2 texOut : TEXCOORD,
			out float4 colOut : COLOR )
{
	float4 NW = mul(float4(normIn, 0.0), matWorldView);
	float4 LW = mul(float4(dirLight.xyz, 0.0), matView);
	posOut = mul(float4(posIn, 1.0), matWorldViewProj);
	colOut = mul(max(-dot(normalize(LW.xyz),normalize(NW.xyz)),0.25f),colLight*colMaterial);
	texOut = texIn;	 
}